/* 
 * LCAUView.h -- Interface file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, nor even that it has a use.
 *
 */

#import <appkit/appkit.h>

@interface LCAUView:View {

	id		keepTop;
	id		aSwitch;
	id		drawBasin;
	id		probFlip;
	id		drawEntpy;
	id		pswit;
	id		drawXBlock;
	id		probView;
	id		probLevel;

	id		basc;
	id		baux;
	id		genEv;
	id		gridSize;
	id		haHa;
	id		histoGram;
	id		wrule;
	id		dataList;
	id		lambdaStyle;
	id		rbutton,sbutton;
	id		ruleNumber;
	id		pslid;
	id		statEnpai;
	id		statEntro;
	id		statLines;
	id		statMode;
	id		statPair;
	id		statState;
	id		statSDevi;
	id		statNhood;
	id		statIndx;
	id		statLamb;
	id		tiDat;
	id		valBx;
	id		varText;
	id		varWindow;
	id		wholePanel;
	
/*  general evolution windows	*/
	id		ev1Window;
	id		ev2Window;
	id		ev3Window;


	id		theBasinView;
	id		theBlockView;
	id		theEntropyView;
	id		thePlaidView;
	id		theProbView;
	id		theStereoView;
	id		theShEvolView;
	id		theThEvolView;

	id		basinWindow;
	id		stereoWindow;
	id		entropyWindow;
	id		evolWindow;
	id		keyWindow;
	id		shEvolWindow;
	id		thEvolWindow;
	id		probWindow;
	id		plaidWindow;
	
	id		probEI, probGens, probGrid;
	
	id		menuCopy;
	id		menuPrint;

	id		delegate;
	id		crossCursor;
}

- clearScreen:sender;
- drawEvolu:sender;
- drawPlane:sender;
- drawPlEvol:sender;
- drawShEvol:sender;
- drawThEvol:sender;
- eaterRule:sender;
- nxasfreq;
- nxmoncar: (int) l;
- printEvolu:sender;
- showCursor:sender;
- setRule:sender;
- prob:sender;
- makeline:sender;

- probHowMany:sender;
- probSetEI:sender;
- probSetGen:sender;
- probSetBlk:sender;
- copyThEvol:sender;
- drawBlock:sender;
- drawNBlock:sender;
- drawProb:sender;
- drawPlaid:sender;
- drawStat:sender;
- evWindow:sender;
- printBlock:sender;
- drawMosaic:sender;
- printMosaic:sender;
- printNBlock:sender;
- printProb:sender;
- printPlaid:sender;
- printStat:sender;
- printPlEvol:sender;
- printShEvol:sender;
- printThEvol:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)theEvent;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;
- awake;
- (const char *)inspectorName;

@end

/* end LCAUView.h */
