
/* 
 * LCAUView.m -- Implementation file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to its
 * fitness for any particular use, or even that it has a use.
 *
 */

#import "LCAUView.h"
#import "drawingFuncs.h"
#import "nxlcau5t.h"
// #import "nxardn5t.h"
#import <math.h> 
#import <dpsclient/psops.h>
#import <dpsclient/wraps.h>
#import <stdlib.h>
#import <string.h>

extern  int binrule[KK][KK][KK][KK];
extern char ascrule[KK][KK][KK][KK];
extern char auxrule[KK][KK][KK][KK];

int    drawArhi=NO;
int    drawBack=YES;
int    drawCross=NO;
int    drawMonc=NO;
int    drawEvol=NO;
int    drawLine=NO;
int    drawMosaic=NO;
int    drawPlane=NO;
int    drawShort=NO;
int    drawThird=NO;
int    drawTMatrix=NO;
int    drawMeanF=NO;
int    draw2Block=NO;
int    drawNBlk=NO;
int    showStat=NO;
int    drawPlaid=NO;
int    drawview=0;

int    probEIV='e';
int    probGenV='1';
int    probBlkV='1';
int    repPlEv=1;

char           aarry[KK][KK][KK][KK];
char     barry[KK][KK][KK][KK][KK][KK][KK];

double cubic[25][25][25];

int    plaidline[2];			/* center for plaid radius contours */

int    srule[2][27];
int    cu=12;

extern NXColor colst[KK];
extern char colorwells[KK][6];

extern double blpr[KK];			/* probability from blocks	*/

extern double stt, sta[5][K3+1];

extern int    co, dn;			/* connectivity, dimension  */
extern char   arule[DS], arr1[], arr2[], arr3[];
extern float  getNumber(NXStream *stream);
extern int    getSeparator(NXStream *stream);

void     serms(double x, double y, int l, int m);
void     shortevolve(int m, int n);
void     nxlcau5t();
double   tdist(int i, int j, int n);
void     wru(char *c);

@implementation LCAUView


void videocursor(p,i,j) int p, i, j; {}
void videoputc(c,i) char c; int i; {}
void videomode(i) int i; {}
void videopalette(i) int i; {}
void videoscroll(i,j,k,l,d,c) int i, j, k, l, d, c; {}
void videocattr(p,c,n,l) int p, c, n, l; {}


void videodot(i,j,l) int i, j, l; {

  NXSetColor(colst[l]);
 
    switch (drawview) {
      case 0:  PSrectfill(2.0*(float)j,398.0-2.0*(float)i,1.25,1.25); break;
      case 1:  PSrectfill(2.0*(float)i,398.0-2.0*(float)j,1.25,1.25); break;
      case 2:  PSrectfill(8.0*(float)j+1.5,60.0-8.0*(float)i,4.75,4.75); break;
      case 3:  PSrectfill(4.0*(float)j+2.0,48.0-4.0*(float)i,3.0,3.0); break;
      case 4:  PSrectfill(2.0*(float)j,100.0-2.0*(float)i,1.25,1.25); break;
      case 5:  PSrectfill(2.0*(float)j,2.0*(float)i,1.5,1.5); break;
      case 6: PSrectfill(2.5*(float)j,2.5*(float)i,9.6,9.6); break;
      case 7:  PSrectfill((float)(4*j+2),(float)4*i,3.125,3.125); break;
      case 8:  PSrectfill(150.0+(float)j,260.0-(float)i,1.0,1.0); break;
      case 9:  PSrectfill(2.0*(float)j,173.0-2.0*(float)i,1.5,1.5); break;
      case 10: PSrectfill((float)j,(float)i,3.125,3.125); break;
      case 11: PSrectfill((float)j,(float)i,1.0,1.0); break;

      default: break;}
      

}

/*  m = line length; n = number of lines   */
/* Version for use with half-integer radii */
void shortevolve(m,n) int m, n; {
int i, j, k, l, o;
  savearry();
  asctobin();
  o=AL/2-m/2;
  for (j=0; j<n; j++) {
    k=j%2; l=j/2;
    for (i=0; i<m; i++) videodot(4*j,4*i-2*k,arr1[(YL+i+o+l)%YL]);
    onegen(YL);
    }
  renewarry();
}

/* index three dimensions */
int inx3(i,j,k) int i, j, k; {return (cu+i)%cu+ cu*((cu+j)%cu+ cu*((cu+k)%cu ));}

void drawsquare() {int i, j;
  for (i=0; i<128; i++) for (j=0; j<128; j++) videodot(j,i,arr1[i*128+j]);
}

void drawcube() {int i, j, k;
  for (i=0; i<32; i++) for (j=0; j<32; j++) for (k=0; k<16; k++) 
    videodot(j+32*(k/4),i+32*(k%4),arr1[ix3(i,j,k)]);
}

void manysquare(i,j) int i, j; {int k, l;
  for (k=0; k<128; k++) for (l=0; l<128; l++)  
    videodot(k+128*i,l+128*j,arr1[ix2(k,l)]);
}

void drawgrid() {int i;
	  PSsetgray(NX_BLACK); 
	  PSsetlinewidth(0.1);
  for (i=0; i<5; i++) {
  PSmoveto((double)(128.0*i),0.0); PSlineto((double)(128.0*i),512.0);}
  for (i=0; i<5; i++) {
  PSmoveto(0.0,(double)(128.0*i)); PSlineto(512.0,(double)(128.0*i));}
  PSstroke();
}

/* --------------------------- E V O L U T I O N --------------------------- */


/* evWindow decides which evolutionary window to display, based */
/* on the dimension of the automaton, which in turn depends on  */
/* how the neighborhood's volume can be factorized		*/

- evWindow:sender {  switch (dn) {
     case 1:  [ev1Window makeKeyAndOrderFront: sender];
	      [ev2Window performClose: sender];
	      [ev3Window performClose: sender];
	      break;
     case 2:  [ev2Window makeKeyAndOrderFront: sender];
	      [ev1Window performClose: sender];
	      [ev3Window performClose: sender];
	      break;
     default: [ev3Window makeKeyAndOrderFront: sender];
	      [ev1Window performClose: sender];
	      [ev2Window performClose: sender];
	      break;}
  return self;
}

- drawShEvol:sender {
    drawview=10;
    drawShort=YES;
    [self display];
    drawShort=NO;

return self;
}

- printShEvol:sender {
    drawview=7;
    drawShort=YES;
    [keyWindow smartPrintPSCode: self];
    drawShort=NO;
return self;
}

- drawThEvol:sender {
    [thEvolWindow makeKeyAndOrderFront: self];
    drawview=6;
    drawThird=YES;
    [thEvolWindow display];
    drawThird=NO;
return self;
}

- printThEvol:sender {
    drawview=6;
    drawThird=YES;
    [keyWindow smartPrintPSCode: self];
    drawThird=NO;
return self;
}

- printLCAU:sender {
    if (keyWindow==shEvolWindow)  [self printShEvol:  sender];
    if (keyWindow==thEvolWindow)  [self printThEvol:  sender];
    if (keyWindow==evolWindow)    [self printEvolu:   sender];
    if (keyWindow==entropyWindow) [self printEntropy: sender];
//    if (keyWindow==statWindow)    [self printStat:    sender];
    if (keyWindow==plaidWindow)   [self printPlaid:   sender];
return self;
}

- windowDidBecomeKey:sender {
	keyWindow=sender;
	[menuCopy setTarget: self];
	[menuCopy setAction: @selector(copyLCAU:)];
	[menuCopy setEnabled: YES];
	[menuPrint setTarget: self];
	[menuPrint setAction: @selector(printLCAU:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
	[menuCopy setEnabled: NO];
	[menuPrint setEnabled: NO];
return self;
}

- copyShEvol:sender {
NXRect zbounds;
id     pBoard;
  drawview=10;
  drawShort=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theShEvolView getBounds: &zbounds];
  [theShEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawShort=NO;
return self;
}

- copyThEvol:sender {
NXRect zbounds;
id     pBoard;
  drawview=6;
  drawThird=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theThEvolView getBounds: &zbounds];
  [theThEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawThird=NO;
return self;
}

- copyEvolu:sender {
NXRect zbounds;
id     pBoard;
  drawview=7;
  drawShort=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theShEvolView getBounds: &zbounds];
  [theShEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawShort=NO;
return self;
}

- copyBasin:sender {
NXRect zbounds;
id     pBoard;
  drawview=9;
  drawBack=NO;
  drawBasin=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theBasinView getBounds: &zbounds];
  [theBasinView writePSCodeInside: &zbounds to: pBoard]; 
  drawBasin=NO;
  drawBack=YES;
return self;
}

- copyEnpy:sender {
NXRect zbounds;
id     pBoard;
  drawview=9;
  drawBack=NO;
  drawEntpy=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theEntropyView getBounds: &zbounds];
  [theEntropyView writePSCodeInside: &zbounds to: pBoard]; 
  drawEntpy=NO;
  drawBack=YES;
return self;
}

- copyProb:sender {
NXRect zbounds;
id     pBoard;
  drawview=9;
  drawBack=NO;
  drawMeanF=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theProbView getBounds: &zbounds];
  [theProbView writePSCodeInside: &zbounds to: pBoard]; 
  drawMeanF=NO;
  drawBack=YES;
return self;
}

- copyNBlock:sender {
NXRect zbounds;
id     pBoard;
  drawview=4;
  drawNBlk=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theBlockView getBounds: &zbounds];
  [theBlockView writePSCodeInside: &zbounds to: pBoard]; 
  drawNBlk=NO;
return self;
}

- copyLCAU:sender {
    if (keyWindow==shEvolWindow)  [self copyShEvol: sender];
    if (keyWindow==evolWindow)    [self copyEvolu:  sender];
    if (keyWindow==entropyWindow) [self copyEnpy:   sender];
    if (keyWindow==plaidWindow)   [self copyPlaid:  sender];
return self;
}

- drawEvolu:sender {
  drawview=0;
  drawEvol=YES;
  [self display];
  drawEvol=NO;
return self;
}

- printEvolu:sender {
//  drawview=1;
  drawview=0;
  drawEvol=YES;
  [keyWindow smartPrintPSCode: self];
//  [self printPSCode:self];
  drawEvol=NO;
return self;
}

- drawPlaid:sender {
  drawview=5;
  [self setFlipped: NO];
  drawPlaid=YES;
  [self display];
  drawPlaid=NO;
  [self setFlipped: YES];
return self;
}

- printPlaid:sender {
  drawview=5;
  [self setFlipped: NO];
  drawPlaid=YES;
    [keyWindow smartPrintPSCode: self];
  drawPlaid=NO;
  [self setFlipped: YES];

return self;
}

double tdist(i,j,n) int i, j, n; {int a[10], b[10], l, m; double kay, s, t, u;
  if (n>10) return 0.0; 
  kay=1.0/((double)KK);
  for (l=0; l<n; l++) a[l]=b[l]=0;
  for (m=i, l=0; l<n; m/=KK, l++) a[n-l-1]=m%KK;
  for (m=j, l=0; l<n; m/=KK, l++) b[n-l-1]=m%KK;
  for (s=0.0, t=1.0, l=0; l<n; t*=kay, l++) {u=a[l]-b[l]; s+=t*((u<0.0)?-u:u);}
  return s*kay;
}


- drawPlEvol:sender {int i;
  repPlEv=[[sender selectedCell] tag];
  printf("drawPlEvol %d\n",repPlEv);
  drawview=7;
  drawPlane=YES;
  asctobin();
  if (repPlEv==0) [self display]; else
    for (i=0; i<repPlEv; i++) {
      [genEv setIntValue: i];
      onegen(AL);
      [self display];
      }
  [genEv setIntValue: repPlEv];
  drawPlane=NO;
return self;
}

- printPlEvol:sender {
    repPlEv=0;
    drawview=7;
    drawPlane=YES;
    [wholePanel smartPrintPSCode: self];
    drawPlane=NO;

return self;
}

/* -------------------------------- L C A U -------------------------------- */

- eaterRule:sender
{int i0, i1, i2, i3;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++) {
  ascrule[i0][i1][i2][i3]=i0+'0';
  if ((i0+1)%KK==i1) ascrule[i0][i1][i2][i3]=i1+'0';
  if ((i0+1)%KK==i2) ascrule[i0][i1][i2][i3]=i2+'0';
  if ((i0+1)%KK==i3) ascrule[i0][i1][i2][i3]=i3+'0';
  }
return self;
}

/* -------------------------------- A R D N -------------------------------- */

/* -------------------------------- R I J N -------------------------------- */

/* -------------------------------- P R O B -------------------------------- */

- prob:sender
{
return self;
}

- probHowMany:sender
{
return self;
}

- probSetEI:sender 
{
int i;
  for (i=0; i<6; i++) [[probEI cellAt:i:0] setState: NO];
  for (i=0; i<6; i++) [[probEI cellAt:i:1] setState: NO];
  [[probEI cellAt:5:0] setState: YES];
  [probEI display];

return self;
}

- probSetBlk:sender 
{
  probBlkV=[[sender selectedCell] title][0];
return self;
}

- probSetGen:sender 
{
  probGenV=[[sender selectedCell] title][0];
return self;
}


- drawProb:sender
{
    drawview=9;
    drawMeanF=YES;
    [self display];
    drawMeanF=NO;
return self;
}

- printProb:sender
{
   drawview=9;
   drawMeanF=YES;
   [wholePanel printPSCode:self];
   drawMeanF=NO;
return self;
}

- drawBlock:sender
{
    drawview=8;
    draw2Block=YES;
    [self display];
    draw2Block=NO;
return self;
}

- printBlock:sender
{
   drawview=8;
   draw2Block=YES;
   [wholePanel smartPrintPSCode:self];
   draw2Block=NO;
return self;
}

- drawNBlock:sender
{
    drawview=4;
    drawNBlk=YES;
    [self display];
    drawNBlk=NO;
return self;
}

- printNBlock:sender
{
   drawview=4;
   drawNBlk=YES;
   [wholePanel smartPrintPSCode:self];
   drawNBlk=NO;
return self;
}

- drawStat:sender
{
    drawview=5;
    showStat=YES;
    [self display];
    showStat=NO;
return self;
}

- printStat:sender
{
   drawview=5;
   showStat=YES;
   [wholePanel smartPrintPSCode:self];
   showStat=NO;
return self;
}

- nxmoncar: (int) l
{
int i, j, k, n, b[KK], bb[KK][KK];
double bf[KK], bbf[KK][KK];
double a[KK], aa[KK], d[KK], el, en, t, tt, s;

// nblclr();
n=[[statLines selectedCell] tag];
asctobin();
el=1.0/((double)YL);
en=1.0/((double)n);
for (i=0; i<KK; i++) {a[i]=0.0; aa[i]=0.0;}
for (k=0; k<n; k++) {
  onegen(YL);
  for (i=0; i<KK; i++) b[i]=0;
  for (i=0; i<YL; i++) b[arr1[i]]++;
  for (i=0; i<KK; i++) bf[i]=((double)(b[i]))*el;
  for (i=0; i<KK; i++) {a[i]+=bf[i]; aa[i]+=bf[i]*bf[i];}
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) bb[i][j]=0;
  for (i=1; i<YL; i++) bb[arr1[i-1]][arr1[i]]++;
  bb[arr1[YL-1]][arr1[0]]++; 
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) 
    bbf[i][j]=((double)(bb[i][j]))*el;
//  videodot(199-(int)(100.0*bbf[1][1]),BORG+(int)(100.0*bf[1]),l);
  }
for (i=0; i<KK; i++) {a[i]*=en; aa[i]*=en;}
s=1.0/log((double)KK);
t=0.0; tt=0.0;
for (i=0; i<KK; i++) t+=bf[i]*log(bf[i]);
for (i=0; i<KK; i++) d[i]=sqrt(aa[i]-a[i]*a[i]);
for (i=0; i<KK; i++) for (j=0; j<KK; j++) tt+=bbf[i][j]*log(bbf[i][j]);
  [statLamb setDoubleValue: 1.0-bf[0]];
  [statEntro setDoubleValue: -t*s];
  [statEnpai setDoubleValue: -0.5*tt*s];
 printf("average      = %5.3f, %5.3f, %5.3f\n",a[0],a[1],a[2]);
 printf("deviation    = %5.3f, %5.3f, %5.3f\n",d[0],d[1],d[2]);
	[statSDevi setDoubleValue: (d[0]+d[1]+d[2])/3.0];
  for (i=0; i<KK; i++) [[statState cellAt: 0: i] setDoubleValue: bf[i]];
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) 
	[[statPair cellAt: 0: i*KK+j] setDoubleValue: bbf[i][j]];
return self;
}

/* graph the frequencies of ascrule 		 */
/* put dot at coordinates (u,v)			 */
/* percentages evolving into each value		 */
/* percentages shifting - adds to more than 100% */
/* entropy and Langton's lambda = % nonquiescent */

- nxasfreq 
{
int    i, j, i0, i1, i2, i3;
int    stat[KK], stal, stac, star;		/* statistic counts */
double staf[KK], t, pp;

pp=1.0/((double)(KK*KK));
stal=0; stac=0; star=0;
for (i=0; i<KK; i++) stat[i]=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++) {
  j=ascrule[i0][i1][i2][i3]-'0';
  stat[j]++;
  if(j==i0) stal++;
  if(j==i1) star++;
  }
for (i=0; i<KK; i++) staf[i]=((double)stat[i])*pp;
// for (i=0; i<KK; i++) printf("%d freq - %5.2f\n",i,staf[i]);
	[statIndx setDoubleValue: ((double)stal)*pp at: 0];
	[statIndx setDoubleValue: ((double)star)*pp at: 1];
// j=199-(int)(100.0*staf[1]);
// i=CORG+(int)(100.0*staf[1]);
// if (j>=2) videodot(j-2,i,l);
// if (i>=2) videodot(j,i-2,l);
// videodot(j,i,1);
// if (i<=318) videodot(j,i+2,l);
// if (j<=198) videodot(j+2,i,l);
for (i=0, t=0.0; i<KK; i++) t+=staf[i]*log(staf[i]);
	[statLamb setDoubleValue: 1.0-staf[0]];
	[statEntro setDoubleValue: -t/log((double)KK)];
return self;
}

/* -------------------------------- * * * * -------------------------------- */

/* - - - - - - - - - - -   L C A U V i e w   - - - - - - - - - - - - - - - - */


- initFrame:(const NXRect *)frameRect
/*
 * Initializes the new LCAUView object.  First, an initFrame: message is sent 
 * to super to initialize LCAUView as a View.  Next, the LCAUView sets its own 
 * state -- that it is opaque and that the origin of its coordinate system lies 
 * in the center of its area.  It then creates and initializes its associated 
 * objects, a Storage object, an NXCursor, and a Cell.  Finally, it loads into 
 * the Window Server some PostScript procedures that it will use in drawing 
 * itself. 
 */
{
	NXPoint	spot;
	
	[super initFrame:frameRect];
/*	[self translate:floor(frame.size.width/2) :floor(frame.size.height/2)]; */
	[self setOpaque:YES];
	crossCursor = 
		[NXCursor newFromImage:[NXImage newFromSection:"cross.tiff"]];
	spot.x = spot.y = 7.0;
	[crossCursor setHotSpot:&spot];

  PSsetgray(NX_BLACK);
  PSselectfont("Times-Roman",16.0);

  [self setFlipped: YES];

	return self;

}


- setDelegate:anObject
/*
 * Sets the LCAUView's delegate instance variable to the supplied object.
 */
{
	delegate = anObject;
	return self;
}


- drawSelf:(const NXRect *)rects :(int)rectCount
/*
 * Draws the LCAUView's background and axes.  If there are any points,
 * these are drawn too.
 *
 * (Note:  For simplicity, although LCAUView only repaints the background 
 * of the update region, it redraws the entire axes.  For better performance, 
 * only those parts of the axes that fall within the update region should 
 * be redrawn.)   
 */
{
        char             c[WNML];
	unsigned int	 i, j, k, l, n;
	int		 ii, jj, nn, bas;
        double           en, p, q, r, s, t, dp, pee, cue;
	double		 aa[KK], bb[KK], cc[KK], cq[KK];
	double		 bern(), dbern(), tbern(), fbern();
	NXPoint		 *aPoint;
	NXRect		 plotRect;

  struct tm  *timeptr;
  time_t  secsnow;

int     i0, i1, ss;
	
	if (rects == NULL) return self;

	/* paint visible area white then draw axes */
	PSsetgray(NX_WHITE);
	if (drawBack) NXRectFill(&rects[0]);
	PSsetgray(NX_DKGRAY);

        if (drawEvol==YES) {
//   wru(c);
//   [ruleNumber setStringValue: c];
	  if ([keepTop state]) savearry();
	  evolve();
	  if ([keepTop state]) renewarry();
	  }

        if (drawShort==YES) {
//   wru(c);
//   [ruleNumber setStringValue: c];
  	  [self getBounds:&plotRect];
	  i=(int)(plotRect.size.width/4.0);
	  j=(int)(plotRect.size.height/4.0);
	  shortevolve(i,j);
	}

        if (drawThird==YES) {
  	  [self getBounds:&plotRect];
	  i=(int)(plotRect.size.width/10.0);
	  j=(int)(plotRect.size.height/10.0);
	  shortevolve(i,j);
	  }

        if (drawPlane==YES) {
//   wru(c);
//   [ruleNumber setStringValue: c];
   switch (dn) {
     case 2: 
	[window setTitle: "Moore (5,1/2) Plane Evolution"];
	drawsquare();
	break;
     case 3: 
	[window setTitle: "3-D cube corner Solid Evolution"];
	drawcube();
	drawgrid();
	break;
     case 5: 
	[window setTitle: "von Neumann (5,1) Plane Evolution"];
	drawsquare();
	break;
     case 6: 
	[window setTitle: "3-D tetrahedral center Solid Evolution"];
	drawcube();
	drawgrid();
	break;
     default: [window setTitle: "LCAU5T Plane Evolution"];break;}
	}

        if (drawMosaic==YES) {
//   wru(c);
//   [ruleNumber setStringValue: c];
   switch (dn) {
     case 2: 
	[window setTitle: "Moore (5,1/2) manysquare Plane Evolution"];
	for (i=0; i<4; i++) for (j=0; j<4; j++) {
	  manysquare(i,j);
	  onegen(AL);
	  [window flushWindow];
	  }
	drawgrid();
	break;
     case 5: 
	[window setTitle: "von Neumann (5,1) manysquare Plane Evolution"];
	for (i=0; i<4; i++) for (j=0; j<4; j++) {
	  manysquare(i,j);
	  onegen(AL);
	  [window flushWindow];
	  }
	drawgrid();
	break;
     default: [window setTitle: "LCAU5T Plane Evolution"];break;}
	}

	if (drawPlaid==YES) {		/* one cycle of evolution */
	  n=[[gridSize selectedCell] tag];
	  if (strcmp([[aSwitch selectedCell] title],"distance")==0) {
	    [ruleNumber setStringValue: "distance matrix"];
	    for (i=0; i<243; i++) for (j=0; j<243; j++) {
	      r=tdist(i,j,5);
	      PSsetcmykcolor(0.1*r,0.8*r,1.0-r,0.55*r);
	      PSrectfill((float)(j),(float)(i),1.0,1.0);
	      }
	    PSstroke();
	    }
	  if (strcmp([[aSwitch selectedCell] title],"circles")==0) {
	    sprintf(c,"center: %3d, %3d\n",plaidline[0],plaidline[1]);
	    [ruleNumber setStringValue: c];
	    for (i=0; i<243; i++) for (j=0; j<243; j++) {
	      p=tdist(i,plaidline[1],5);
	      q=tdist(j,plaidline[0],5);
	      s=(p+q);
	      PSsetcmykcolor(s,0.05*p,1.0-s,0.05*q);
	      PSrectfill((double)(j),(double)(i),1.0,1.0);
	      }
	    PSstroke();
	    PSsetgray(NX_BLACK); 
	    PSrectfill((double)plaidline[0],(double)plaidline[1],2.0,2.0);
	    PSstroke();
	    }
	  if (strcmp([[aSwitch selectedCell] title],"plaid")==0) {
//	    wru(c);
//	    [ruleNumber setStringValue: c];
	    savearry();
	    asctobin();
	    for (j=0; j<128; j++) {
	      ranlin();
	      for (i=0; i<64; i++) {onegen(YL); pprob();}
	      }
	    renewarry();
	  }
	if (n>0) {
	  PSsetgray(NX_BLACK); 
	  PSsetlinewidth(0.0);
	  for (j=1, dp=243.0, i=0; i<n; i++) {j*=3; dp*=0.333;}
	  for (i=0, p=1.0; i<j+1; i++, p+=dp) {
	    PSmoveto(0.1,p);
	    PSlineto(243.0,p);
	    PSmoveto(p,0.1);
	    PSlineto(p,243.0);
	    }
	  PSstroke();
	  }
	}


        if (drawMeanF==YES) {
//   wru(c);
//   [ruleNumber setStringValue: c];
	if ([[probEI cellAt:5:0] state]) lifreq(100,0,0,2);
	if ([[probEI cellAt:4:0] state]) pdiff(100,6);
	if ([[probEI cellAt:3:0] state]) pddiff(100,6);
//	if ([[probEI cellAt:2:0] state]) ptdiff(100,6);
//	if ([[probEI cellAt:1:0] state]) pfdiff(100,6);
//	if ([[probEI cellAt:0:0] state]) pvdiff(100,6);

//	if ([[probEI cellAt:4:1] state]) pidiff(100,6,1);
//	if ([[probEI cellAt:3:1] state]) pidiff(100,6,2);
//	if ([[probEI cellAt:2:1] state]) pidiff(100,6,3);
//	if ([[probEI cellAt:1:1] state]) pidiff(100,6,4);
//	if ([[probEI cellAt:0:1] state]) pidiff(100,6,5);

	if ([probGrid state]) {
	     PSsetlinewidth(0.0);
	     PSsetgray(NX_BLACK);
	     linegrid(10);
	     PSstroke();
	     }

//	  for (i=0; i<6; i++) if ([[probEI cellAt:i:0] state]) procur('e',5-i);
//	  for (i=0; i<6; i++) if ([[probEI cellAt:i:1] state]) procur('i',5-i);
		}

	if (drawBasin==YES) {
/* graph the probability differential for state l over 	*/
/* an extended triangle 	 			*/
//   wru(c);
//   [ruleNumber setStringValue: c];
	if ([[probEI cellAt:5:0] state]) bas=0; 
	if ([[probEI cellAt:4:0] state]) bas=1;
	if ([[probEI cellAt:3:0] state]) bas=2;
	if ([[probEI cellAt:2:0] state]) bas=3; 
	if ([[probEI cellAt:1:0] state]) bas=4;
	if ([[probEI cellAt:0:0] state]) bas=5;

	if ([[probEI cellAt:4:1] state]) bas=6;
	if ([[probEI cellAt:3:1] state]) bas=7;
	if ([[probEI cellAt:2:1] state]) bas=8;
	if ([[probEI cellAt:1:1] state]) bas=9;
	if ([[probEI cellAt:0:1] state]) bas=10;

nn=100;
en=1.0/((double)(nn));
// for (ii=-nn; ii<=3*nn; ii++) {
//   for (jj=-nn; ii+jj<=2*nn; jj++) {
for (ii=0; ii<=nn; ii++) {
for (jj=0; ii+jj<=nn; jj++) {
    aa[0]=((double)(ii))*en;
    aa[1]=((double)(jj))*en;
    aa[2]=1.0-aa[0]-aa[1];
    switch (bas) {
      case 0: cq[0]=aa[0]; cq[1]=aa[1]; cq[2]=aa[2];
              break;
      case 1: cq[0]=bern(0,aa); cq[1]=bern(1,aa); cq[2]=bern(2,aa);
              break;
      case 2: cq[0]=dbern(0,aa); cq[1]=dbern(1,aa); cq[2]=dbern(2,aa);
	      break;
//      case 3: cq[0]=tbern(0,aa); cq[1]=tbern(1,aa); cq[2]=tbern(2,aa);
//	      break;
//      case 4: cq[0]=fbern(0,aa); cq[1]=fbern(1,aa); cq[2]=fbern(2,aa);
//	      break;
      case 5: break;

      case 6: cq[0]=bern(0,aa); cq[1]=bern(1,aa); cq[2]=bern(2,aa);
              break;
      case 7: bb[0]=bern(0,aa); bb[1]=bern(1,aa); bb[2]=bern(2,aa);
	      cq[0]=bern(0,bb); cq[1]=bern(1,bb); cq[2]=bern(2,bb);
              break;
      case 8: bb[0]=bern(0,aa); bb[1]=bern(1,aa); bb[2]=bern(2,aa);
	      cc[0]=bern(0,bb); cc[1]=bern(1,bb); cc[2]=bern(2,bb);
	      cq[0]=bern(0,cc); cq[1]=bern(1,cc); cq[2]=bern(2,cc);
	      break;
      case 9: bb[0]=bern(0,aa); bb[1]=bern(1,aa); bb[2]=bern(2,aa);
	      cc[0]=bern(0,bb); cc[1]=bern(1,bb); cc[2]=bern(2,bb);
	      bb[0]=bern(0,cc); bb[1]=bern(1,cc); bb[2]=bern(2,cc);
	      cq[0]=bern(0,bb); cq[1]=bern(1,bb); cq[2]=bern(2,bb);
	      break;
      case 10: bb[0]=bern(0,aa); bb[1]=bern(1,aa); bb[2]=bern(2,aa);
	      cc[0]=bern(0,bb); cc[1]=bern(1,bb); cc[2]=bern(2,bb);
	      bb[0]=bern(0,cc); bb[1]=bern(1,cc); bb[2]=bern(2,cc);
	      cc[0]=bern(0,bb); cc[1]=bern(1,bb); cc[2]=bern(2,bb);
	      cq[0]=bern(0,cc); cq[1]=bern(1,cc); cq[2]=bern(2,cc);
	      break;
      default: break;
      }
//   if ([probFlip state]) tcolordot(cq,aa); else tcolordot(aa,cq);
    }
  }
	     PSstroke();

	if ([probGrid state]) {
	     PSsetlinewidth(0.0);
	     PSsetgray(NX_BLACK);
	     linegrid(10);
	     PSstroke();
	     }

	}

	if (drawEntpy==YES) {
	     penry(100);
	     PSsetlinewidth(0.05);
	     PSsetgray(NX_BLACK);
	     linegrid(10);
	     PSstroke();
	     PSsetlinewidth(0.0);
           }

	if (draw2Block==YES) {}

	if (drawXBlock==YES) {

// printf("hello from XBlock\n");

//   wru(c);
//   [ruleNumber setStringValue: c];

   time(&secsnow);
   timeptr = localtime(&secsnow);
   sprintf(c,"%d-%d-19%02d\n",
	((timeptr->tm_mon) + 1), 
	timeptr->tm_mday,
        timeptr->tm_year);
   [tiDat setStringValue: c];

    l=0;
    if (strcmp([[probView selectedCell] title],"front")==0) l=0;
    if (strcmp([[probView selectedCell] title],"plan")==0) l=1;
    if (strcmp([[probView selectedCell] title],"side")==0) l=2;

    if ([[probLevel cellAt: 0: 0] state]) {
	  PSsetlinewidth(0.0);
	  PSsetcmykcolor(0.2,0.0,1.0,0.0);
	cudem(cubic,25,25,25,6);
    for (i=0; i<24; i++) for (j=0; j<24; j++) for (k=0; k<24; k++) {
      conth(cubic,0.0,i,j,k,l);
	}
		PSstroke();
      }
    if ([[probLevel cellAt: 1: 0] state]) {
	  PSsetlinewidth(0.0);
	  PSsetcmykcolor(0.0,1.0,0.2,0.0);
	cudem(cubic,25,25,25,7);
    for (i=0; i<24; i++) for (j=0; j<24; j++) for (k=0; k<24; k++) {
      conth(cubic,0.0,i,j,k,l);
	}
		PSstroke();
      }
    if ([[probLevel cellAt: 2: 0] state]) {
	  PSsetlinewidth(0.0);
	  PSsetcmykcolor(1.0,0.0,0.2,0.0);
	cudem(cubic,25,25,25,8);
    for (i=0; i<24; i++) for (j=0; j<24; j++) for (k=0; k<24; k++) {
      conth(cubic,0.0,i,j,k,l);
	}
		PSstroke();
      }
    }

	if (drawNBlk==YES) {
//   wru(c);
//   [ruleNumber setStringValue: c];
	  nblcur(probBlkV);
	  for (i=0; i<KK; i++) [[haHa cellAt: 0: i] setDoubleValue: blpr[i]];
	  }

	if (showStat==YES) {
//   wru(c);
//   [ruleNumber setStringValue: c];
	    if (strcmp([[statNhood selectedCell] title],"totalistic")==0) {
		[self nxmoncar: 2];
		neisum(0,YL,48);
                }
	    if (strcmp([[statNhood selectedCell] title],"general")==0) {
		[self nxmoncar: 2];
		gnlsum(0,YL,48);
                }
	  }

        if (drawArhi==YES) {
      for (i0=0; i0<5; i0++) for (i1=0; i1<K3+1; i1++) sta[i0][i1]=0.0;
      for (i1=0; i1<K3+1; i1++) sta[3][i1]=10.0;
      stt=0.0;
//      allmo(&stt,sta);
      ss=1;
		}

        if (drawLine==YES) {
        for (j=0; j<8; j++) for (i=0; i<40; i++) videodot(j,i,arr1[i+40*j]);
	}

	return self;
}

- sizeTo:(NXCoord)width :(NXCoord)height
/*
 * Ensures that whenever the LCAUView is resized, the origin of its 
 * coordinate system is repositioned to the center of its area.
 */
{
//	  [self setFlipped: YES];
	[super sizeTo:width :height];
	if (drawview==4||drawview==7||drawview==10) 
		{[self setDrawOrigin: 0 :0]; return self;}
	else    [self setDrawOrigin: -floor(width/2): -floor(height/2)]; 
	return self;
}

- mouseDown:(NXEvent *) theEvent
/*
 * Responds to a message the system sends whenever the user presses the mouse
 * button when the cursor is over the LCAUView.  The LCAUView changes the 
 * cursor to a cross-hairs image and then starts asking for mouse-dragged or 
 * mouse-up events.  As it receives mouse-dragged events, the LCAUView updates 
 * the readOut text Cell with the cursor's coordinates.  If the user releases 
 * the mouse button while the cursor is over the LCAUView, the LCAUView 
 * registers the point and then sends a message to its delegate notifying it 
 * of the new point.
 */
{
	int	looping = YES, oldMask;
	NXPoint	aPoint;
	NXRect	plotRect, cellRect;

         double  x, y, ex, wy, eks, wye;
	 int k;

	[crossCursor set];
   	[self getBounds:&plotRect];
 	NXSetRect(&cellRect, plotRect.origin.x, plotRect.origin.y, 100.0, 20.0);

	oldMask = [window addToEventMask:NX_MOUSEDRAGGEDMASK];
 				[window setDocEdited:YES];
		                aPoint = theEvent->location;
		                [self convertPoint:&aPoint fromView:nil];
                                ex=aPoint.x;
                                wy=aPoint.y;
				k=nearest(ex,wy);

//       if (theEvent->data.mouse.click==3) {} else 
//       if (theEvent->data.mouse.click==2) {} else 
	{
	[self lockFocus];
//         PSsetinstance(YES);
	do {
// 		PSnewinstance();
		aPoint = theEvent->location;
		[self convertPoint:&aPoint fromView:nil];
//                ex=aPoint.x;
//                wy=aPoint.y;
		if (theEvent->type == NX_MOUSEUP) {looping = NO;}	
   	} while (looping && (theEvent = 
		[NXApp getNextEvent:NX_MOUSEUPMASK|NX_MOUSEDRAGGEDMASK]));
	[self unlockFocus];


	}
	[window setEventMask:oldMask];
	[NXArrow set];
	return self;
}

- read:(NXTypedStream *)stream
/*
 * Unarchives the LCAUView.  Initializes four of the LCAUView's instance 
 * variables to the values stored in the stream. 
 */
{
	[super read:stream];
	return self;
}

- write:(NXTypedStream *)stream
/*
 * Archives the LCAUView by writing its important instance variables to the 
 * stream. 
 */
{
	[super write:stream];
	return self;
}

- awake
/*
 * Finishes initializing a LCAUView that has just been unarchived (see the 
 * read: method).
 */
{
	return [super awake];
}


- (const char *)inspectorName
{
    return "LCAUViewInspector";
}

@end

/* end LCAUView.m */
