
/* 
 * LiulGuph.m -- Implementation file for the LiulGuph class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to its
 * fitness for any particular use, nor even that it has a use.
 *
 */

#import "LiulGuph.h"
#import "drawingFuncs.h"
#import "nxlcau5t.h"
#import "nxrijn5t.h"
#import <math.h> 
#import <objc/Storage.h>
#import <dpsclient/psops.h>
#import <dpsclient/wraps.h>
#import <stdlib.h>
#import <string.h>
#include <stdio.h>
#include <time.h>

int    cnstRijn=NO;
int    drawBasic=NO;
int    drawRijn=NO;
int    justRijn=NO;
int    shortRijn=NO;

extern int    drawview;

int    rijnPerm;
int    rijnShift;
int    rijnGen;

extern double dcntr[][2];

extern int    dd;		/* radius of de Bruijn ring */
extern int    co, dn;		/* connectivity, dimension  */

extern NXColor colst[KK];

int    dbno=0;			/* node number in de Bruijn diagram 	*/

extern char   ascrule[KK][KK][KK][KK];
extern int    dd;		/* radius of de Bruijn ring */
extern char   arule[DS], arr1[AL], arr2[AL], arr3[AL];

void   asctobin();
int    closeto(double x, double y);
void   edcyl(int *arry, int cc, int k, int l, int cn, int m);
void   edijn(int g, int s, int p, int r);
void   edPair(int l, int pc, int pa, int pl, int pv);
void   edSubset(int l, int pc, int pa, int pl, int pv);
void   finderset(int *e, twoparn *t);
void   geanc(int ance[][21], int *link, int cp);
void   gecyl(int *arry, int cy, int bl, int br, int l);
void   geroo(int *root, int *comp, int *link, int cp);
void   howdown(int *sud);
int    level (int n);
int    prnins(int i, twoparn *z);
int    prouts(int i, twoparn *z);
void   prxtrmd(int *min, int *max);
void   prxtrml(int *min, int *max);
int    putlevel(twoparn *zmat, twoparn *xmat, int n);
int    shflev(int g, int s);
void   shortevolve(int m, int n);
void   suanc();
void   upthere(int *sud);
void   wrru(char *c, char ru[KK][KK][KK][KK]);

@implementation LiulGuph


/* --------------------------- T I M E  -  D A T E-------------------------- */

void telltime() {
/* 
    Turbo C Reference Guide Version 2.0 (1988)
    Borland International.
    Chapter2, The Turbo C library, pag. 226.
*/

  struct tm  *timeptr;
  time_t  secsnow;

/*  timezone = 8*60*60; */
   time(&secsnow);
   timeptr = localtime(&secsnow);
   printf("The date is %d-%d-19%02d\n",
          ((timeptr->tm_mon) + 1), timeptr->tm_mday,
           timeptr->tm_year);
   printf("Local time is %02d:%02d:%02d\n",
          timeptr->tm_hour, timeptr->tm_min,
         timeptr->tm_sec);
}

/* -------------------------------- R I J N -------------------------------- */

- showRijn:sender 
{
printf("dbWindow is about to load %d\n",dn);
    if (dbWindow==nil) {
      if (![NXApp loadNibSection: "rijn.nib" owner: self withNames: NO]) 
	{return nil;}
//    rootViews = [[List alloc] init];
//    rootWindows = [[List alloc] init];
//    [cyWidth setEmptySelectionEnabled: YES];
//    [cyWidth selectCellAt: -1: 0];
//    [browser setEmptySelectionEnabled: YES];
//    [browser setMultipleSelectionEnabled: NO];
//    [browser getTitleFromPreviousColumn: NO];
//    [browser setTitle: "components" ofColumn: 0];
//    [self setGraphData];
    }
 	      [dbWindow makeKeyAndOrderFront: sender];
//	      [db3Window performClose: sender];
//  wru(ch);
//  [ruleNumber setStringValue: ch];
//   [self ruinReset: self];
   [dbView rijnReset: self];

//  [nodeNumber setIntValue: 0];
//  [self ediOpt: self];
printf("dbWindow is loaded\n");
  return self;
}

- rijn:sender
{int i;
       if (sender==gen2) rijnGen=0; 
  else if (sender==gen3) rijnGen=1; 
  else                   rijnGen=2; 
  rijnShift=  [sender selectedCol];
  [self rijnReset: self];
  [sender selectCellAt: 0: rijnShift];
  i=shflev(rijnGen,rijnShift);
  [underDiagram setEmptySelectionEnabled: YES];
  [[underDiagram selectedCell] setIntValue: 0];
  [[underDiagram cellAt: 0: i] performClick: self];
  [underDiagram selectCellAt: 0: i];
  [whichConstant setEmptySelectionEnabled: YES];
  [whichConstant selectCellAt: -1: 0];
  rijnPerm=[whichPermutation selectedRow];
  edijn(rijnGen,rijnShift,rijnPerm,![dbBranches state]);
  cnstRijn=NO;
return self;
}

- rijnConst:sender
{
  rijnGen=[sender selectedRow];
  rijnShift=[sender selectedCol];
  [self rijnReset: self];
  [sender selectCellAt: rijnGen: rijnShift];
  [underDiagram setEmptySelectionEnabled: YES];
  [[underDiagram selectedCell] setIntValue: 0];
  [[underDiagram cellAt: 0: rijnGen] performClick: self];
  [underDiagram selectCellAt: 0: rijnGen];
  [whichShift setEmptySelectionEnabled: YES];
  [whichShift selectCellAt: -1: 0];
  rijnPerm=[whichPermutation selectedRow];
  edijn('A'-'a'+rijnGen,rijnShift,rijnPerm,![dbBranches state]);
  cnstRijn=YES;
return self;
}

- rijnReset:sender 
{
  [gen2 setEmptySelectionEnabled: YES];
  [gen2 selectCellAt: -1: 0];
  [gen3 setEmptySelectionEnabled: YES];
  [gen3 selectCellAt: -1: 0];
  [gen4 setEmptySelectionEnabled: YES];
  [gen4 selectCellAt: -1: 0];
  [whichConstant setEmptySelectionEnabled: YES];
  [whichConstant selectCellAt: -1: 0];
  [underDiagram setEmptySelectionEnabled: YES];
  [[underDiagram selectedCell] setIntValue: 0];
return self;
}

/* dd = k^(2r)*k^(2*level) */
- rijnHowBig:sender
{
int    i;
double th, dt;
    switch([sender selectedCol]) {
      case 0:  dd=125; break;
//      case 1:  dd=729; break;
      default: dd=125; break;}
  dt=6.28318/((double)(dd));
  for (i=0, th=0.5*dt; i<dd; i++, th+=dt) {
    dcntr[i][0]=200.0-180.0*sin(th);
    dcntr[i][1]=200.0-180.0*cos(th);
    }

return self;
}

- rijnRanSam:sender
{
int  i;
  i='z';
  if (strcmp([[sender selectedCell] title],"random sample")==0) i='r';
  if (strcmp([[sender selectedCell] title],"selected node")==0) i='n';
  if (strcmp([[sender selectedCell] title],"scan links")==0)    i='i';
  if ([dbBranches state]) {return self;}
  if (cnstRijn) edshc(rijnGen,i); edshf(rijnGen,rijnShift,i);
  [evWindow makeKeyAndOrderFront: sender];
  [evButton performClick: sender];
return self;
}

- basicRijn:sender 
{char c[WNML], d[37+WNML];
  drawview=0;
  drawBasic=YES;
		[self rijnReset:self];
  		[[underDiagram cellAt: 0: 0] performClick: self];
//  wru(c);
  sprintf(d,"lcau5t basic de Bruijn diagram");
  [sparePanel makeKeyAndOrderFront:self];
  [sparePanel setTitle: d];
  [spareView display];
  drawBasic=NO;
return self;
}

- Zot:sender
{
    drawview=0;
    shortRijn=YES;
    [self display];
    shortRijn=NO;
return self;
}

- shewRijn:sender
{
    drawview=0;
    justRijn=YES;
    [self display];
    justRijn=NO;
return self;
}

- printBasic:sender 
{char c[WNML], d[37+WNML];
  drawview=0;
  drawBasic=YES;
		[self rijnReset:self];
  		[[underDiagram cellAt: 0: 0] performClick: self];
//  wru(c);
  sprintf(d,"lcau5t basic de Bruijn diagram");
  [sparePanel makeKeyAndOrderFront:self];
  [sparePanel setTitle: d];
  [spareView display];
  [sparePanel smartPrintPSCode:self];
  drawBasic=NO;
return self;
}

- printGeneric:sender 
{
  drawview=0;
  justRijn=YES;
  [sparePanel makeKeyAndOrderFront:self];
  [sparePanel setTitle: "generic lcau5t de Bruijn diagram"];
  [spareView display];
  [sparePanel smartPrintPSCode:self];
  justRijn=NO;
return self;
}

- printRijn:sender
{
  drawview=0;
  shortRijn=YES;
  [self printPSCode:self];
  shortRijn=NO;
return self;
}

/* - - - - - - - - - - - - -    L I U L G U P H   - - - - - - - - - - - - - */


- initFrame:(const NXRect *)frameRect
/*
 * Initializes the new LiulGuph object.  First, an initFrame: message is sent 
 * to super to initialize LiulGuph as a View.  Next, the LiulGuph sets its own 
 * state -- that it is opaque and that the origin of its coordinate system lies 
 * in the center of its area.  It then creates and initializes its associated 
 * objects, a Storage object, an NXCursor, and a Cell.  Finally, it loads into 
 * the Window Server some PostScript procedures that it will use in drawing 
 * itself. 
 */
{
	NXPoint	spot;
	
	[super initFrame:frameRect];
/*	[self translate:floor(frame.size.width/2) :floor(frame.size.height/2)]; */
	[self setOpaque:YES];
	crossCursor = [NXCursor 
		newFromImage:[NXImage newFromSection:"cross.tiff"]];
	spot.x = spot.y = 7.0;
	[crossCursor setHotSpot:&spot];

  PSsetgray(NX_BLACK);
  PSselectfont("Times-Roman",16.0);

  [self setFlipped: YES];

	return self;

}


- setDelegate:anObject
/*
 * Sets the LiulGuph's delegate instance variable to the supplied object.
 */
{
	delegate = anObject;
	return self;
}


- drawSelf:(const NXRect *)rects :(int)rectCount
/*
 * Draws the LiulGuph's background and axes.  If there are any points,
 * these are drawn too.
 *
 * (Note:  For simplicity, although LiulGuph only repaints the background 
 * of the update region, it redraws the entire axes.  For better performance, 
 * only those parts of the axes that fall within the update region should 
 * be redrawn.)   
 */
{
        char             c[40], timday[30];
	unsigned int	 i, j, k;
        double           p, q, s, dp, pee, cue;
  struct tm  *timeptr;
  time_t  secsnow;

int     i0, i1, ss;
	
	if (rects == NULL) return self;

	/* paint visible area white then draw axes */
	PSsetgray(NX_WHITE);
	NXRectFill(&rects[0]);
	PSsetgray(NX_DKGRAY);

// drawAxes(bounds.origin.x, bounds.origin.y, bounds.size.width, bounds.size.height);

   time(&secsnow);
   timeptr = localtime(&secsnow);
   sprintf(timday,"%d-%d-19%02d\n",
	((timeptr->tm_mon) + 1), 
	timeptr->tm_mday,
        timeptr->tm_year);

/* for the de Bruijn  diagram --- - - - - - - - - - - - - - - - - - - - - */

        if (drawBasic==YES) {
		PSsetgray(NX_BLACK); 
   [[Font newFont: "Times-Bold" size: 24.0 matrix:NX_FLIPPEDMATRIX] set];
		for (i=0; i<KK; i++) sijn(i,i); 
		PSstroke();
		}

        if (drawRijn==YES) {
		PSsetgray(NX_BLACK); 
		ijn(dd,KK,1); 
		PSstroke();
		[evButton performClick: self];
   [timeDate setStringValue: timday];
		}

        if (justRijn==YES) {
		PSsetgray(NX_BLACK); 
		ijn(dd,KK,1); 
		PSstroke();
   [timeDate setStringValue: timday];
		}

        if (shortRijn==YES) {
  	[[Font newFont: "Courier" size: 20.0 matrix:NX_FLIPPEDMATRIX] set];
   wrru(c,ascrule);
   [ruleNumber setStringValue: c];
   PSmoveto(290.0,14.0);
   PSshow(c);
   PSmoveto(12.0,14.0);
  	[[Font newFont: "Courier" size: 12.0 matrix:NX_FLIPPEDMATRIX] set];
   if (cnstRijn) sprintf(c,"evolving to %1d in %1d gen",rijnShift,rijnGen+1); 
	else {if (rijnPerm==0) 
	  sprintf(c,"shift %1d in %1d gen",-rijnShift,rijnGen+1);
	  else 
sprintf(c,"shift %1d in %1d gen perm %d",-rijnShift,rijnGen+1,rijnPerm);}
   PSshow(c);
  	[[Font newFont: "Courier" size: 10.0 matrix:NX_FLIPPEDMATRIX] set];
		PSsetgray(NX_BLACK); 
		if (cnstRijn) edcst(rijnGen); else edshg(rijnGen,rijnShift);
		PSstroke();

   [timeDate setStringValue: timday];

		}

	return self;
}

- sizeTo:(NXCoord)width :(NXCoord)height
/*
 * Ensures that whenever the LiulGuph is resized, the origin of its 
 * coordinate system is repositioned to the center of its area.
 */
{
//	  [self setFlipped: YES];
	[super sizeTo:width :height];
	if (drawview==4||drawview==7) 
		{[self setDrawOrigin:0 :0]; return self;}
	if (drawview!=4) 
		[self setDrawOrigin:-floor(width/2) : -floor(height/2)]; 
	return self;
}

- mouseDown:(NXEvent *) theEvent
/*
 * Responds to a message the system sends whenever the user presses the mouse
 * button when the cursor is over the LiulGuph.  The LiulGuph changes the 
 * cursor to a cross-hairs image and then starts asking for mouse-dragged or 
 * mouse-up events.  As it receives mouse-dragged events, the LiulGuph updates 
 * the readOut text Cell with the cursor's coordinates.  If the user releases 
 * the mouse button while the cursor is over the LiulGuph, the LiulGuph 
 * registers the point and then sends a message to its delegate notifying it of 
 * the new point.
 */
{
	int	looping = YES, oldMask;
	NXPoint	aPoint;

         double  x, y, ex, wy, eks, wye;
	 int i, j, k;

	[crossCursor set];

	oldMask = [window addToEventMask:NX_MOUSEDRAGGEDMASK];

/* for the de Bruijn  diagram --- - - - - - - - - - - - - - - - - - - - - */

 				[window setDocEdited:YES];
		                aPoint = theEvent->location;
		                [self convertPoint:&aPoint fromView:nil];
                                ex=aPoint.x;
                                wy=aPoint.y;
				dbno=nearest(ex,wy);
				[nodeNumber setIntValue: dbno];

       if (theEvent->data.mouse.click==3) {} else 
       if (theEvent->data.mouse.click==2) {
		eks=0.05*(ex-200.0);
		wye=0.05*(wy-200.0);
				dcntr[dbno][0]=ex-eks;
				dcntr[dbno][1]=wy-wye;
		} else {
	[self lockFocus];
         PSsetinstance(YES);
	do {
 		PSnewinstance();
		aPoint = theEvent->location;
		[self convertPoint:&aPoint fromView:nil];
                ex=aPoint.x;
                wy=aPoint.y;
				PSsetgray(NX_BLACK);
				PSmoveto(ex+12.0,wy);
				PSarc(ex, wy, 12.0, 0.0, 360.0);
				PSstroke();
				dcntr[dbno][0]=ex;
				dcntr[dbno][1]=wy;
		[window flushWindow];
		if (theEvent->type == NX_MOUSEUP) {looping = NO;}	
   	} while (looping && 
	(theEvent=[NXApp getNextEvent:NX_MOUSEUPMASK|NX_MOUSEDRAGGEDMASK]));
	[self unlockFocus];


   shortRijn=YES;
//   [window display];
   [self display];
   shortRijn=NO;

  }

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */ 

	[window setEventMask:oldMask];
	[NXArrow set];
	return self;
}

- read:(NXTypedStream *)stream
/*
 * Unarchives the LiulGuph.  Initializes four of the LiulGuph's instance 
 * variables to the values stored in the stream. 
 */
{
	[super read:stream];
	return self;
}

- write:(NXTypedStream *)stream
/*
 * Archives the LiulGuph by writing its important instance variables to the 
 * stream. 
 */
{
	[super write:stream];
	return self;
}

- awake
/*
 * Finishes initializing a LiulGuph that has just been unarchived (see the 
 * read: method).
 */
{
	return [super awake];
}


- (const char *)inspectorName
{
    return "LiulGuphInspector";
}

@end

/* end LiulGuph.m */
