
/* 
 * RulePanel.h -- Interface file for the RulePanel class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, nor even that it has a use.
 *
 */

#import <appkit/appkit.h>

@interface RulePanel:View {

/* Rule Panel  - - - - - - - - - - - - - - - - - - - - - - - - - */

	id		infoPanel;
	id		mainWindow;
	id		menuCopy;
	id		menuPrint;
	id		nowBox;
	id		nowSpesh;
	id		speshPanel;

/* panel control - - - - - - - - - - - - - - - - - - - - - - - - */

	id		arithmRuleBox;
	id		composRuleBox;
	id		equivRuleBox;
	id		miscRuleBox;
	id		specBigBox;
	id		specLilBox;
	id		subsetRuleBox;

	id		sem0,sem1,sem2;
	id		ascru;
	id		pSliders;
	id		pWindows;
	id		ruleNumber;
	id		totlRef;
	id		sIncr;
	id		tiDat;
	id		wrule;

	id		s00,s01,s02,s10,s11,s12,s20,s21,s22;

	id		gfWindow;

	id		stRuleNumber;
	id		stWindow;

/* totalistic rules  - - - - - - - - - - - - - - - - - - - - - */

	id		toascru;
	id		toRuleBox;
	id		toRuleNumber;
	id		toWindow;

	id		statEntro;
	id		statIndx;
	id		statLamb;
	id		statState;
	id		statXeno;
	id		statPairs;
	id 		statPentro;

	id		designPrm;
	id		designRef;
	id		zeZeZe;

	id 		twoRules;

        id 		browser;
        id 		changeLine;

	id 		RECLine;
	id 		RECPanel;
	id		RECValue;

	id		composRuleNumb;

}

- arithmCombs:sender;
- initTwoRules:sender;

- freeAllRules:sender;
- ranRules:sender;
- ranPRules:sender;
- relatedRule:sender;
- readWRule:sender;
- protectGenRule:sender;
- setAllRules:sender;
- setDemo:sender;
- setDimension:sender;
- setRule:sender;
- setTotRule:sender;
- showProbability:sender;
- symRule:sender;
- zeroRules:sender;

- randomLine:sender;
- sCellLine:sender;
- uniformLine:sender;

- enterGF5Rule:sender; 
- setMCoeff:sender;
- setSCoeff:sender;
- setVCoeff:sender;

- enterSemiRule:sender;
- setSemiState:sender;

/* Totalistic Rule  - - - - - - - - - - - - - - - - - - - - - */
- enterTotalisticRule:sender;
- ranTRule:sender;
- readTRule:sender;
- setTotalisticState:sender;
- setTotRule:sender;
- setTotRules:sender;

- xenophilic:sender;
- xenophobic:sender;

- clearDesign:sender;
- copyToDesign:sender;
- deZign:sender;
- enterDesign:sender;

- enterMiscRule:sender;

- nxasfreq; 

- runRECLine:sender;
- useRecLine:sender;

- composRule:sender;
- compxRule:sender;
- comprRule:sender;

- loadLowerPanel:thisRuleBox;  
- loadSpecialRule:sender;


@end 

/* end RulePanel.h */ 
