
# include <math.h>
#import <dpsclient/psops.h>
#import <dpsclient/wraps.h>

void   confr(int vv);
void   conth(double z[25][25][25], double c, int i, int j, int k, int vv);
void   conzp(int *vi, double *zp, double a, double b, int i);
void   cudem(double f[25][25][25], int l, int m, int n, int v);
double nmlz(double p);
void   plths(double x, double y, int l);

/* find the three-dimensional contour lying within one single cube */
/* z[25][25][25] array containing function values 		   */
/* c             contour value					   */
/* i, j, k	 corner of contour cube				   */
/* vv		 view (front, side, plan)			   */

void conth(z,c,i,j,k,vv) double z[25][25][25], c; int i, j, k, vv; {
int    i0, i1, i2;
int    l, m, n, vi[19], fa[18];
int    ej[19][6] = {		/* increments locating endpoint */
		0,0,0, 1,0,0,
		0,0,0, 0,1,0,
		0,0,0, 0,0,1,
		0,0,0, 1,1,0,
		0,0,0, 1,0,1,
		0,0,0, 0,1,1,

		0,0,0, 1,1,1,

		0,0,1, 1,0,1,
		1,0,1, 1,0,0,
		1,0,0, 1,1,0,
		1,1,0, 0,1,0,
		0,1,0, 0,1,1,
		0,1,1, 0,0,1,

		1,1,1, 1,0,0,
		1,1,1, 0,1,0,
		1,1,1, 0,0,1,
		1,1,1, 1,1,0,
		1,1,1, 1,0,1,
		1,1,1, 0,1,1
		};
int    tr[18][3] = {		/* edges forming triangle */
		4,7,2,
		0,8,4,
		0,9,3,
		3,10,1,
		1,11,5,
		5,12,2,

		15,7,17,
		18,12,15,
		17,8,13,
		13,9,16,
		14,10,16,
		18,11,14,

		2,6,15,
		3,16,6,
		0,13,6,
		18,5,6,
		4,17,6,
		18,7,14
		};
int    te[6][4]={		/* triangles forming tetrahedron */
		7,14,12,5,
		6,16,12,0,
		8,16,15,1,
		9,13,15,2,
		11,14,17,4,
		10,13,17,3
		};
double a, b;			 /* relative position of contour along edge */
double zp[19];
double u[3], v[3], w[3];

/* decide upon which view (front, side, plan) will be shown) */

switch (vv) {
  case 0: i0=0; i1=1; i2=2; break;
  case 1: i0=1; i1=0; i2=2; break;
  case 2: i0=0; i1=2; i2=1; break;
  default: break;}

/* decide which of 19 edges cross the contour */

for (l=0; l<19; l++) conzp(vi,zp,z[i+ej[l][0]][j+ej[l][1]][k+ej[l][2]]-c,
		z[i+ej[l][3]][j+ej[l][4]][k+ej[l][5]]-c,l);

/* decide which of the 18 faces contain contour lines */

for (l=0; l<18; l++) fa[l]=vi[tr[l][0]]+2*(vi[tr[l][1]]+2*vi[tr[l][2]]);

/* draw the contour lines */ 

for (l=0; l<18; l++) {
  w[0]=(double)i-11.251;
  w[1]=(double)j-11.167;
  w[2]=(double)k-11.337;
  switch(fa[l]) {
    case 0: break;
    case 1: break;
    case 2: break;
    case 3:
      a=zp[tr[l][0]]; b=zp[tr[l][1]];
      for (m=0; m<3; m++) {
      u[m]=w[m]+(1.0-a)*(double)ej[tr[l][0]][m]+a*(double)ej[tr[l][0]][m+3];
      v[m]=w[m]+(1.0-b)*(double)ej[tr[l][1]][m]+b*(double)ej[tr[l][1]][m+3];
      }
  plths(u[i0]+0.167*u[i1],u[i2]+0.125*u[i1],0);
  plths(v[i0]+0.167*v[i1],v[i2]+0.125*v[i1],1);
      break;
    case 4: break;
    case 5:
      a=zp[tr[l][0]]; b=zp[tr[l][2]];
      for (m=0; m<3; m++) {
      u[m]=w[m]+(1.0-a)*(double)ej[tr[l][0]][m]+a*(double)ej[tr[l][0]][m+3];
      v[m]=w[m]+(1.0-b)*(double)ej[tr[l][2]][m]+b*(double)ej[tr[l][2]][m+3];
      }
  plths(u[i0]+0.167*u[i1],u[i2]+0.125*u[i1],0);
  plths(v[i0]+0.167*v[i1],v[i2]+0.125*v[i1],1);
      break;
    case 6:
      a=zp[tr[l][1]]; b=zp[tr[l][2]];
      for (m=0; m<3; m++) {
      u[m]=w[m]+(1.0-a)*(double)ej[tr[l][1]][m]+a*(double)ej[tr[l][1]][m+3];
      v[m]=w[m]+(1.0-b)*(double)ej[tr[l][2]][m]+b*(double)ej[tr[l][2]][m+3];
      }
  plths(u[i0]+0.167*u[i1],u[i2]+0.125*u[i1],0);
  plths(v[i0]+0.167*v[i1],v[i2]+0.125*v[i1],1);
      break;
    case 7: break;
    default: break;}
  }
}

void conzp(vi,zp,a,b,i) int *vi; double *zp, a, b; int i; {
     if (a==b) {
        vi[i]=0;
        zp[i]=0.0;
        }
else if ((a<0.0&&b>0.0)||(a>0.0&&b<0.0)) {
        vi[i]=1;
        zp[i]=-a/(b-a);
        }
else     {
       vi[i]=0;
       zp[i]=0.0;
       }
}

void cudem(f,l,m,n,v) double f[25][25][25]; int l, m, n, v; {
int    i, j, k;
double x, y, z, p, q, t[3];
double ex, wy, ze;
double sqsu(), dsqsu(), tsqsu(), isqsu(), jsqsu(), ksqsu(), nmlz();
for (i=0; i<l; i++) for (j=0; j<m; j++) for (k=0; k<n; k++) {
  x=0.08166*(double)(i-12);
  y=0.08166*(double)(j-12);
  z=0.08166*(double)(k-12);
		t[0]=x;
		t[1]=y;
		t[2]=z;
  switch (v) {
    case 0: f[i][j][k]=(x*x+y*y+z*z)/41.0; break;
    case 1: f[i][j][k]=(x+y+z+0.125)/6.0; break;
    case 2: f[i][j][k]=(x*x+y*y-2.0*z*z)/41.0; break;
    case 3: p=sqrt(x*x+y*y)-8.5; f[i][j][k]=p*p+z*z; break;
    case 4: break;
    case 5: f[i][j][k]=(x*x-1.2*y*y-2.0*z*z)/41.0; break;
    case 6: f[i][j][k]=bern(0,t)-t[0]; break;
    case 7: f[i][j][k]=bern(1,t)-t[1]; break;
    case 8: f[i][j][k]=bern(2,t)-t[2]; break;
//    case 9: f[i][j][k]=sqrt(isqsu(t)); break;
//    case 10: f[i][j][k]=sqrt(jsqsu(t)); break;
//    case 11: f[i][j][k]=sqrt(ksqsu(t)); break;
    default: f[i][j][k]=0.0; break;}
  }
}

double nmlz(p) double p; {
	if (p<0.0) return 0.0;
	if (p>1.0) return 1.0;
	return p;
}

void confr(vv) int vv; {
int    i0, i1, i2;
double u[3], v[3];
double w[4][3] = {
  -11.251, -11.167, -11.337,
  -11.251, 13.0, 13.0,
  13.0, -11.167, 13.0, 
  13.0, 13.0, -11.337
  };

switch (vv) {
  case 0: i0=0; i1=1; i2=2; break;
  case 1: i0=1; i1=0; i2=2; break;
  case 2: i0=0; i1=2; i2=1; break;
  default: break;}

  plths(w[0][i0]+0.167*w[0][i1],w[0][i2]+0.125*w[0][i1],0);
  plths(w[1][i0]+0.167*w[1][i1],w[1][i2]+0.125*w[1][i1],1);
  plths(w[2][i0]+0.167*w[2][i1],w[2][i2]+0.125*w[2][i1],1);
  plths(w[3][i0]+0.167*w[3][i1],w[3][i2]+0.125*w[3][i1],1);
  plths(w[0][i0]+0.167*w[0][i1],w[0][i2]+0.125*w[0][i1],1);
  plths(w[2][i0]+0.167*w[2][i1],w[2][i2]+0.125*w[2][i1],1);
  
  plths(w[1][i0]+0.167*w[1][i1],w[1][i2]+0.125*w[1][i1],0);
  plths(w[3][i0]+0.167*w[3][i1],w[3][i2]+0.125*w[3][i1],1);
}

void plths(x,y,l) double x, y; int l; {
  if (l==0) PSmoveto(170.0+12.0*y,360.0-(170.0+12.0*x));
  if (l==1) PSlineto(170.0+12.0*y,360.0-(170.0+12.0*x));
}

/* end conth.c */



/*
if (drawContour) {

  if (strcmp([viewMenu title],"front")==0) v=0;
  if (strcmp([viewMenu title],"side")==0)  v=1;
  if (strcmp([viewMenu title],"plan")==0)  v=2;

  if (strcmp([[contourMenu selectedCell] title],"sphere")==0) i=0;
  if (strcmp([[contourMenu selectedCell] title],"plane")==0)  i=1;
  if (strcmp([[contourMenu selectedCell] title],"1-sheet h")==0)  i=2;
  if (strcmp([[contourMenu selectedCell] title],"torus")==0)  i=3;
  if (strcmp([[contourMenu selectedCell] title],"bitorus")==0)  i=4;
  if (strcmp([[contourMenu selectedCell] title],"2-sheet h")==0)  i=5;
  if (strcmp([[contourMenu selectedCell] title],"cubic")==0)  i=6;
  if (strcmp([[contourMenu selectedCell] title],"ellipsoid")==0)  i=7;
      cudem(cubic,25,25,25,i);
    if (i==4) p=0.0; else p=[sulfSlider doubleValue];
    for (i=0; i<24; i++) for (j=0; j<24; j++) for (k=0; k<24; k++)
      conth(cubic,p,i,j,k,v);

    if (drawView==5) PSstroke();

}
*/

/* end conth.c */
