
/* nxlcau5t.h			*/
/* header for nxlcau5t.c	*/
/* 5 October 1989		*/

# define COLGRAF     4  /* graph resolution			*/
# define T80X25      3  /* text resolution			*/
# define WHCYMAG     1  /* color quad for normal screen		*/
# define YELREGR     2  /* color quad for alternative screen	*/
# define CR	     5  /* cursor reference - row editor	*/
# define CM	     7  /* cursor reference - main menu		*/
# define CL	    11  /* cursor reference - line editor	*/
# define TRR	    16  /* row showing totalistic rule number	*/
# define TRC	    56  /* column for totalistic rule number	*/
# define XRR	    12  /* row displaying totalistic rule	*/
# define XRC	    56  /* column for totalistic rule		*/
# define AL      16384  /* array length (screen width)		*/
# define SL	    40	/* short array length			*/
# define YL        320  /* array length (screen width)		*/
# define TS	    17	/* distinct sums w/totalistic rule	*/
# define SS	    17  /* distinct sums semitotalistic rule    */
# define DS	   625  /* (number of distinct neighborhoods)	*/
# define KK	     5  /* number of states per cell		*/
# define RR	     4  /* length of neighborhood = 2r+1	*/ 
# define DN (KK*KK*KK)	/* number of distinct nodes		*/
# define PDN       729	/* nodes in pair diagram = KK^4r	*/
# define SDN     15625	/* nodes in subset diagram = 2^(KK^2r)	*/
# define DDN	  3125	/* maximum nodes de Bruijn diagram	*/
# define QDN	  4096	/* maximum nodes 2-D de Bruijn diagram	*/
# define QWN	  1024  /* node list 2-D de Bruijn node & link  */
# define BD	    31  /* maximum degree of b.p.		*/

# define RSYM	   240	/* number of rule symmetries = 2*k!	*/
# define WNML	   314	/* arry size for base 25 wolfram number */

# define CCY          4		/* circumference of max length cycle	*/
# define XCY	    625		/* max number of cycles = KK^CCY	*/

# define XAN	     52		/* nominal max number of ancestors/node	*/

# define K2     (KK*KK) 
# define K3     (KK*KK*KK) 
# define K4	(K2*K2)
# define K5	(K2*K3)
# define K6	(K3*K3)
# define K8	(K4*K4)
# define AV	(KK*KK)
# define HH	60		/* points in histogram */

# define CLEN 300	/* buffer length for rec source     */
# define PLEN 900	/* buffer length for rec object     */
# define XLEN 128	/* buffer length for rec predefined */
# define NY    24

typedef union birular {
		int one[KK*KK*KK*KK]; 
		int four[KK][KK][KK][KK];
		} birular;
typedef union parneih {
		int one[K3*K3];
		int two[K3][K3];
	 	int six[KK][KK][KK][KK][KK][KK];
		} parneih;
typedef union twoparn {
		int one[K6*K6];
		int two[K6][K6]; 
		int four[K3][K3][K3][K3];
		int twelve[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
		} twoparn;

/* end nxlcau5t.h*/
