# include <ctype.h>
# include "rec.h"
    
/*	Counter.  A counter is a predicate !n! with n+1 states.  It is
	TRUE the first n times it is executed, and it is FALSE the (n+1)-st;
	this cycle repeats indefinitely.  A compiler incorporating this
	predicate will (typically) define the exclamation point as having
	compilation and execution entry points r_ctrc and r_ctrx, 
	respectively.  r_ctrc checks the character following the last digit
	for equality with the character introducing the predicate, so other
	likely characters are $ and # (e.g., $n$ or #n#)		*/

/*	This module adds the following error return	*/
/*	-13	Syntax error in counter			*/

r_ctrc(func)
Inst func;
{
    int t, c, r_xpred();
    long val;

    t = r_lastchar;
    r_code(r_xpred);
    r_code(func);
    val = 0L;
    while ((c = r_nxtchar()) != -1 && isdigit(c))
	val = 10L * val + c - '0';
    if (c != t)
	r_errterm(13);
    r_code((Inst) val);
    r_code((Inst) val);
    r_linkf();		/* link into false chain */
}

r_ctrx()
{
    int val;
    
    if (val = (*((long *) r_pc) != 0L))
	(*((long *) r_pc))--;
    else
	*r_pc = *(r_pc + 1);
    r_pc += 2;
    return val;
}
